<template>
    <div class="container">
        <h3 class="text-primary pt-3 text-end">Oxem <i class="text-warning">Vue test task</i></h3>
       
        <transition name="fade">
            <form @submit.prevent>
                <dialog-input v-model:show="dialogVisible">
                        <table class="table  table-borderless mt-5">
                            <input-table 
                                v-model:inputData="inputData"
                                ref="id"
                                >
                            </input-table>
                        </table>
                    <div class="custom_hight_50 mt-5">
                        <transition name="slide-fade">
                            <button 
                            class="float-end btn btn-info text-white"
                            v-show="isShowButton"
                            type="submit"
                            @click="addElement"
                            >
                                Добавить в таблицу
                            </button>
                        </transition>
                    </div>
                </dialog-input>
            </form>
        </transition>
        
        <div class=" d-flex w-100 mb-5 mt-5 justify-content-between">
            <button 
                class="btn btn-info text-white px-3 align-self-end"
                type="button" 
                @click="this.dialogVisible = true"
            >
                <span>Добавить</span>
            </button>

            <form @submit.prevent class="w-50 d-flex">
                <input
                        class="form-control"
                        type="text"
                        v-model.trim="searchInput"
                        id="search"
                        placeholder="Поиск"
                    >
                <button class="btn btn-secondary  mx-1" type="submit">Найти</button>
            </form>
        </div>
        
        <table class="table table-hover">
            <head-table 
                :items="inputData" 
                @clickSort="selectedSort"
            >
            </head-table>
            <items-table 
                v-if="!isLoadingData"
                v-model:itemsContent="searchItemsContent" 
                @removeElement="removeElement"
                @itemInfo="itemInfoByid"
            >
            </items-table>
            <div 
                class="text-danger mt-5" 
                v-else><h5>Загрузка элементов ....</h5>
            </div>
        </table>
        
        <element-info 
           :itemInfo="itemInfo"
        >
        </element-info>
        <pages-number @changePage="changePage" :totalPage="totalPage" :page="page"></pages-number>
    </div>
</template>

<script>
import InputTable from './UI/InputTable.vue';
import ItemsTable from './UI/ItemsTable.vue';
import axios from 'axios';
import ElementInfo from './UI/ElementInfo.vue';
import PagesNumber from './UI/PagesNumber.vue';



export default{
    name: "HomePage",
    components: { InputTable, ItemsTable, ElementInfo, PagesNumber },
    data() {
        return {
           
            isShowButton: false,
            fullArrElem: [],
            itemsContent: [],
            itemInfo: {},
            dialogVisible: false,
            isLoadingData: false,
            searchInput: '',
            totalPage: 0,
            rows: 1000,
            limitRows: 50,
            page: 1,
            inputData: [
                { id: 1, name: "id", type: "number", title: "id", placeholder: "Id", isRequired: true},
                { id: 2, name: "firstName", type: "text", title: "Имя", placeholder: "Имя", isRequired: true},
                { id: 3, name: "lastName", type: "text", title: "Фамилия", placeholder: "Фамилия", isRequired: true },
                { id: 4, name: "email", type: "email", title: "Адрес электронной почты", placeholder: "Электронная почта", isRequired: true},
                { id: 5, name: "phone", type: "phone", title: "Телефон", placeholder: "Телефон", isRequired: true},
            ]
        };
    },
    methods: {
        addElement() {
            const arr = [];
                
            this.inputData.forEach(el => {
                arr[el.name] = el.value;
                arr['address'] = {};
            });
            
            let resId = this.fullArrElem.map(el => el.id);
                            
            if(resId.some(el => el === arr['id'])){
                alert('Елемент с id: ' + arr['id'] + ' уже существует, введите другой id');
                this.$refs.id.$el.children[1].children[0].children[0].value = '';
                this.$refs.id.$el.children[1].children[0].children[0].focus();   
            } else{
               
                this.fullArrElem.unshift({ ...arr });
                this.isShowButton = false;
                this.dialogVisible = false;
                this.inputData.some(el => el.value = '');
                this.loadPages();
            }   
        },

        async fetchData(){
            try {  
                this.isLoadingData = true; 
                const response = await axios.get('http://www.filltext.com/?id={number|1000}&firstName={firstName}&lastName={lastName}&email={email}&phone={phone|(xxx)xxx-xx-xx}&address={addressObject}&description={lorem|32}',{
                    params: {
                        rows:this.rows,
                    }
                });         
                this.fullArrElem.push(...response.data); 
                let uniq = {};
                this.fullArrElem = this.fullArrElem.filter(obj => !uniq[obj.id] && (uniq[obj.id] = true)); 
            } catch (e) {
                alert('Ошибка загрузки данных');
            } finally {
                this.isLoadingData = false;
            }
        },

        selectedSort(id) {
            let nameElement = '';
            let sortStat = false;
            this.inputData.forEach(el => {
                if(el.id === id){
                    el.sort = !el.sort;
                    nameElement = el.name;
                    sortStat = el.sort;
                } else {
                    el.sort = false; 
                }
            });

            this.sortArray(sortStat, nameElement);
        },

        sortArray(sortStat, nameElement) {
            if(sortStat){
                if(nameElement !== 'id'){
                    this.fullArrElem = this.fullArrElem.sort((a,b) => {
                        return a[nameElement]?.localeCompare(b[nameElement]);
                    }); 
                } else {
                    this.fullArrElem = this.fullArrElem.sort((a,b) => {
                        return a[nameElement] - b[nameElement];
                    });
                }
                
            } else {
                if(nameElement !== 'id'){
                    this.fullArrElem = this.fullArrElem.sort((a,b) => {
                    return b[nameElement]?.localeCompare(a[nameElement]);
                    }); 
                } else {
                    this.fullArrElem = this.fullArrElem.sort((a,b) => {
                        return b[nameElement] - a[nameElement];
                    });
                }    
            }
        },
        itemInfoByid(id) {
            this.itemsContent.forEach(el => {
                if(el.id === id){
                    this.itemInfo = {
                        id: el.id,
                        firstName: el.firstName,
                        lastName: el.lastName,
                        description:el.description,
                        streetAddress: el.address.streetAddress,
                        sity: el.address.sity,
                        state: el.address.state,
                        zip: el.address.zip
                    }
                }
            });
        },

        loadPages(){
            this.totalPage = Math.ceil(this.fullArrElem.length / this.limitRows);
            let start = (this.page - 1) * this.limitRows ;
            let end = start + this.limitRows;
            this.itemsContent = this.fullArrElem.slice(start, end);
        },
        removeElement(id) {
            this.fullArrElem = this.fullArrElem.filter(p => p.id !== id);   
            this.itemInfo  = {}; 
        },

        changePage(pageNum) {
            this.page = pageNum;
        },
    },
    mounted() {
        this.fetchData();
        },

    watch: {
        inputData: {
            handler(newValue) {
                let arr = newValue.map(el => el.value)
                let isEmptyField = arr.some(el => !el);                                         
                !isEmptyField ? this.isShowButton = true : this.isShowButton = false; 
                // newValue.forEach(el =>{
                //     if(el.name === 'firstName' && el.value){
                //         if(!el.value.match(/[A-z]/)){
                //             alert('Введите корректные данные')
                //             el.value = '';
                //         }
                            
                //     }else if(el.name === 'lastName' && el.value){
                //         if(!el.value.match(/[A-z]/)){
                //             alert('Введите корректные данные')
                //             el.value = '';
                //         }
                //     }
                // })
            },
            deep: true
        },

        fullArrElem: {
            handler() {
                this.loadPages();
            },
            deep:true
        },

        page() {
            this.loadPages();
        }
    },

    computed: {
        searchItemsContent() {
            return this.itemsContent.filter(item => item.firstName.toLowerCase().includes(this.searchInput.toLowerCase()));
        },
    }
}
</script>

<style scoped>
.cursor{
    cursor: pointer;
}
.custom_hight_125{
    height: 125px;
}
.custom_hight_50{
    height: 50px;
}
.delete_hover:hover{
    background-color: white;
    border-radius:1px;
}
.fade-enter-active,
.fade-leave-active{
  transition: opacity 0.4s ease;
}
.fade-enter-from,
.fade-leave-to {
  opacity: 0;
}
.slide-fade-enter-active {
  transition: all 0.3s ease-out;
}

.slide-fade-leave-active {
  transition: all 0.3s cubic-bezier(1, 0.5, 0.8, 1);
}

.slide-fade-enter-from,
.slide-fade-leave-to {
  transform: translateY(20px);
  opacity: 0;
}
</style>